<?php

class Forms extends Controller {

  function Forms()
  {
    parent::Controller();
    if($this->session->userdata('loggedin') !== '1')
    {
      redirect('main','location');
    }
    $this->load->model('configmodel');
    global $databaseName;
    $databaseName = $this->session->userdata('selectedPlotName');
  }

  function index()
  {
    redirect('forms/selectdatabase');
  }

  function formname()
  {
    if(isset($this->session->userdata['formName']))
    {
      $this->session->unset_userdata('formName');
    }
    $message = '';
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Select Form Name";
    $data['formHeading'] = "";
    $data['formOpen'] = form_open("forms/formnamevalidate");
    $data['table'] = $this->_selectFormNameTable($message);
    $data['backLink'] = "";
    $this->load->view('forms/simpleform',$data);
  }

  function formnamevalidate()
  {
    global $databaseName;
    $formNameTbx = $this->input->post('formNameTbx');
    if(!empty($formNameTbx))
    {
      $checkFormNameQuery = $this->configmodel->checkFormName($formNameTbx,$databaseName);
      if($checkFormNameQuery->num_rows() > 0)
      {
        $message = "<p class='errorblock'>Form Name already Exist, Choose another name for a new form.</p>";
      }
      else
      {
        $message = "";
      }
      $this->_validateFormName('textBox');
      $formName = $formNameTbx;
    }
    else
    {
      $message = "";
      $this->_validateFormName('dropDown');
      $formName = $this->input->post('formNameDD');
    }
    if($this->form_validation->run() == FALSE || $message != "")
    {
      $data['title'] = "Configuration Form";
      $data['contentTitle'] = "Select Form Name";
      $data['formHeading'] = "";
      $data['formOpen'] = form_open("forms/formnamevalidate");
      $data['backLink'] = "";
      $data['table'] = $this->_selectFormNameTable($message);
      $this->load->view('forms/simpleform',$data);
    }
    else
    {
      $this->session->set_userdata('formName',$formName);
      redirect('forms/addcolumn');
    }
  }

  function _selectFormNameTable($message)
  {
    $formName = set_value('formNameTbx');

    $databaseName = $this->session->userdata('selectedPlotName');
    $formNameDDA = $this->configmodel->getFormNameList($databaseName);

    $formNameTbxA = array('name'=>'formNameTbx','id'=>'formNameTbx','size'=>'20','maxlength'=>'40','value'=>$formName);

    $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');


    $formNameDD = form_dropdown('formNameDD',$formNameDDA);
    $formNameTbx = form_input($formNameTbxA);
    $submitButton = form_button($submitButtonA);

    $formNameDDErr = form_error('formNameDD');
    $formNameTbxErr = form_error('formNameTbx');
    if($formNameTbxErr == "")
    {
      $formNameTbxErr = " (Alphabetical Characters Only)";
    }

    $formTableA = array(array(),
                        array('Select Form : ',$formNameDD,$formNameDDErr),
                        array('OR','',$message),
                        array('Create New : ',$formNameTbx,$formNameTbxErr),
                        array('','<p style="text-align:center;">'.$submitButton.'</p>')
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }

  function _validateFormName($columnType)
  {
    if($columnType == 'dropDown')
    {
      $this->form_validation->set_rules('formNameDD', 'Form Name', 'callback_dropdown_check');
    }
    else
    {
      $this->form_validation->set_rules('formNameTbx', 'Form Name', 'required|alpha|max_length[40]');
    }
    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }

  function addcolumn()
  {
    if(!isset($this->session->userdata['formName']))
    {
      redirect('forms/formname');
    }

    global $databaseName;
    $formName = $this->session->userdata('formName');


    $plotColumnQuery = $this->configmodel->getDataByFormName($databaseName,$formName);

    $this->table->set_empty("&nbsp;");
    if($plotColumnQuery->num_rows() > 0)
    {
      $this->table->set_heading('Number', 'Column','Action');
      $plotColumnResult = $plotColumnQuery->result();
      foreach($plotColumnResult as $plotColumnRow)
      {
        $dataEntryConfigID = $plotColumnRow->DataEntryConfig_ID;
        $attributesArray = explode("\t",$plotColumnRow->Attributes);
        $columnHeader = $attributesArray[0];
        $this->table->add_row($plotColumnRow->ColumnNumber,$columnHeader,
          			          anchor('forms/deleteColumn/'.$dataEntryConfigID,'delete',array('class'=>'delete','onclick'=>"return confirm('Are you sure, you want to delete this record?')"))  );
      }
    }
    else
    {
       $this->table->add_row('No Columns Added Yet. Please Click "Add a New Column".');
    }
    $data['table'] = $this->table->generate();

    //Add a button to Add New Column
    $addLink = anchor('forms/selectcolumntype/','Add a New Column',array('class'=>'add'));
    if($plotColumnQuery->num_rows() > 0 )
    {
       $addLink = $addLink."&nbsp;&nbsp;&nbsp;".anchor('forms/sortlist/','Rearrange Columns',array('class'=>'update'))
                            ."&nbsp;&nbsp;&nbsp;"
                            .anchor('newplant/createform/','Preview Form',array('class'=>'view', 'target'=>'_blank'))
                            ."<br />"
                            .anchor('forms/createconfigfile/','Create Config File For Single Data Entry',array('class'=>'write'))
                            ."<br />"
                            .anchor('forms/createdoubleconfigfile/','Create Config Files For Double Data Entry',array('class'=>'write'))
                            ;
    }

    $data['addLink'] = $addLink;
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "List of Columns - ".$formName;
    $data['formHeading'] = "";
    $this->load->view('forms/columnlist',$data);
  }



  function selectcolumntype()
  {
    //after the addcolumn page
    //select the type of column to be added

    $formName = $this->session->userdata('formName');

    $this->table->set_empty("&nbsp;");
    $this->table->add_row(anchor('formtypes/textform/','Simple textbox with text, integer or decimal values without limits',array('class'=>'add')));
    $this->table->add_row(anchor('formtypes/limitform/','Simple textbox with numeric value with limits',array('class'=>'add')));
    $this->table->add_row(anchor('formtypes/userdropdown/','Add User dropdown',array('class'=>'add')));
    $this->table->add_row(anchor('formtypes/twotextform/','Simple textbox with a prefix value',array('class'=>'add')));
    $data['table'] = $this->table->generate();

    $data['backLink'] = anchor('forms/addcolumn/','Back',array('class'=>'back'));
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Select a Column Type - ".$formName;
    $data['formHeading'] = "";
    $this->load->view('forms/selectcolumntype',$data);

  }

  function dropdown_check($str)
  {
     if($str == 'default')
     {
        $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
        return FALSE;
     }
     else
     {
        return True;
     }
  }



  function deleteColumn($dataEntryConfigID)
  {
    $formName = $this->session->userdata('formName');
    $this->configmodel->deleteColumn($dataEntryConfigID);
    $this->_resetColumnNumbers($formName);
    redirect('forms/addcolumn');
  }

  function _resetColumnNumbers($formName)
  {
    global $databaseName;
    $plotColumnQuery = $this->configmodel->getDataByFormName($databaseName,$formName);
    $plotColumnCount = $plotColumnQuery->num_rows();
    $i = 1;
    if($plotColumnCount > 0)
    {
      foreach($plotColumnQuery->result() as $plotColumnRow)
      {
        $this->configmodel->resetColumnNumber($plotColumnRow->DataEntryConfig_ID,$i);
        $i++;
      }
    }
  }

  function sortlist()
  {
    if(!isset($this->session->userdata['formName']))
    {
      redirect('forms/formname');
    }
   ;
    $formName = $this->session->userdata('formName');

    global $databaseName;
    $plotColumnQuery = $this->configmodel->getDataByFormName($databaseName,$formName);

    if($plotColumnQuery->num_rows() > 0 )
    {
      $sortList = "<ul>";
      $plotColumnResult = $plotColumnQuery->result();
      foreach($plotColumnResult as $plotColumnRow)
      {
        $dataEntryConfigID = $plotColumnRow->DataEntryConfig_ID;
        $attributesArray = explode("\t",$plotColumnRow->Attributes);
        $columnHeader = $attributesArray[0];
        $sortList = $sortList.'<li id="recordsArray_'.$dataEntryConfigID.'">'.$plotColumnRow->ColumnNumber.". ".$columnHeader.'</li>';
      }
      $sortList = $sortList."</ul>";

    }
    else
    {
       $sortList = 'No Columns Added Yet. Please Click "Add a New Column" First.';
    }
    $data['list'] = $sortList;

    $data['button']= '<p><input type="button" value="Update" onclick="updateList()"/></p>';

    $data['backLink'] = anchor('forms/addcolumn/','Back',array('class'=>'back'));
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Sort Column List - ".$formName;
    $data['formHeading'] = "";
    $data['formOpen'] = form_open('forms/updatesortinglist');
    $this->load->view('forms/sortlist',$data);
  }

  function updatesortlist()
  {
    $updateRecordsArray = $_POST['recordsArray'];

    $listingCounter = 1;
	foreach ($updateRecordsArray as $dataEntryConfigID)
    {
        $this->configmodel->resetColumnNumber($dataEntryConfigID,$listingCounter);
		$listingCounter = $listingCounter + 1;
	}
    $color = $this->_randomcolor();
    echo '<span style="color:#'.$color.'; font-size:medium;">List Updated!!</span>';
  }

  function _randomcolor()
  {
    mt_srand((double)microtime()*1000000);
    $c = '';
    while(strlen($c)<6){
        $c .= sprintf("%02X", mt_rand(0, 200));
    }
    return $c;
  }

  function createconfigfile()
  {

    global $databaseName;
    $formName = $this->session->userdata('formName');

    $plotColumnQuery = $this->configmodel->getDataByFormName($databaseName,$formName);

    if($plotColumnQuery->num_rows() > 0)
    {
      $this->load->helper('file');

      $fileName = $formName."_".$databaseName;
      $fileName = str_replace(" ","",$fileName);
      $header = join('$',array("ColumnNumber","ColumnType","Attributes"));
      $nextline = "\r\n";

      write_file('./files/configfiles/'.$fileName.'.txt', $header,'w+');

      write_file('./files/configfiles/'.$fileName.'.txt', $nextline,'a');

      $plotColumnResult = $plotColumnQuery->result();
      foreach($plotColumnResult as $plotColumnRow)
      {
        $dataRow = join('$',array($plotColumnRow->ColumnNumber,$plotColumnRow->ColumnType,$plotColumnRow->Attributes));
        write_file('./files/configfiles/'.$fileName.'.txt', $dataRow,'a');
        write_file('./files/configfiles/'.$fileName.'.txt', $nextline,'a');
      }
    }
    $data['text'] = '<div class="success">Config File Created.</div>';
    $data['backLink'] = anchor('forms/addcolumn/','Back',array('class'=>'back'));
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "File Created - ".$formName;
    $data['formHeading'] = "";
    $this->load->view('forms/simpletext',$data);
  }

   function createdoubleconfigfile()
  {

    global $databaseName;
    $formName = $this->session->userdata('formName');

    $plotColumnQuery = $this->configmodel->getDataByFormName($databaseName,$formName);

    for($x=1;$x<=2;$x++)
    {
      if($plotColumnQuery->num_rows() > 0)
      {
        $this->load->helper('file');

        $fileName = $formName.$x."_".$databaseName;
        $fileName = str_replace(" ","",$fileName);
        $header = join('$',array("ColumnNumber","ColumnType","Attributes"));
        $nextline = "\r\n";

        write_file('./files/configfiles/'.$fileName.'.txt', $header,'w+');

        write_file('./files/configfiles/'.$fileName.'.txt', $nextline,'a');

        $plotColumnResult = $plotColumnQuery->result();
        foreach($plotColumnResult as $plotColumnRow)
        {
          $dataRow = join('$',array($plotColumnRow->ColumnNumber,$plotColumnRow->ColumnType,$plotColumnRow->Attributes));
          write_file('./files/configfiles/'.$fileName.'.txt', $dataRow,'a');
          write_file('./files/configfiles/'.$fileName.'.txt', $nextline,'a');
        }
      }
    }
    $data['text'] = '<div class="success">Config Files Created.</div>';
    $data['backLink'] = anchor('forms/addcolumn/','Back',array('class'=>'back'));
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "File Created - ".$formName;
    $data['formHeading'] = "";
    $this->load->view('forms/simpletext',$data);
  }

}